# std::deque< Type, Alloc > Class Template Reference
[Containers, Sequences]

A standard container using fixed-size memory allocation and constant-time manipulation of elements at either end. More...

`#include <stl_deque.h>`

Inheritance diagram for std::deque< Type, Alloc >:

[legend]
List of all members.

## Public Member Functions

| deque (const allocator_type &a=allocator_type())
| Default constructor creates no elements.
| deque (size_type n, const value_type &value, const allocator_type &a=allocator_type())
| Create a deque with copies of an exemplar element.
| deque (size_type n)
| Create a deque with default elements.
| deque (const deque &x)
| Deque copy constructor.
template<typename InputIterator> | deque (InputIterator first, InputIterator last, const allocator_type &a=allocator_type())
| Builds a deque from a range.
| ~deque ()
deque & | operator= (const deque &x)
| Deque assignment operator.
void | assign (size_type n, const value_type &__val)
| Assigns a given value to a deque.
template<typename InputIterator> void | assign (InputIterator first, InputIterator last)
| Assigns a range to a deque.
allocator_type | get_allocator () const
| Get a copy of the memory allocation object.
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
size_type | max_size () const
void | resize (size_type new_size, const value_type &x)
| Resizes the deque to the specified number of elements.
void | resize (size_type new_size)
| Resizes the deque to the specified number of elements.
bool | empty () const
reference | operator[] (size_type n)
| Subscript access to the data contained in the deque.
const_reference | operator[] (size_type n) const
| Subscript access to the data contained in the deque.
reference | at (size_type n)
| Provides access to the data contained in the deque.
const_reference | at (size_type n) const
| Provides access to the data contained in the deque.
reference | front ()
const_reference | front () const
reference | back ()
const_reference | back () const
void | push_front (const value_type &x)
| Add data to the front of the deque.
void | push_back (const value_type &x)
| Add data to the end of the deque.
void | pop_front ()
| Removes first element.
void | pop_back ()
| Removes last element.
iterator | insert (iterator position, const value_type &x)
| Inserts given value into deque before specified iterator.
void | insert (iterator position, size_type n, const value_type &x)
| Inserts a number of copies of given data into the deque.
template<typename InputIterator> void | insert (iterator position, InputIterator first, InputIterator last)
| Inserts a range into the deque.
iterator | erase (iterator position)
| Remove element at given position.
iterator | erase (iterator first, iterator last)
| Remove a range of elements.
void | swap (deque &x)
| Swaps data with another deque.
void | clear ()

## Detailed Description

### template<typename Type, typename Alloc = allocator<Type>>
class std::deque< Type, Alloc >

A standard container using fixed-size memory allocation and constant-time manipulation of elements at either end.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements.

In previous HP/SGI versions of deque, there was an extra template parameter so users could control the node size. This extension turned out to violate the C++ standard (it can be detected using template template parameters), and it was removed.

Definition at line 585 of file stl_deque.h.

## Constructor & Destructor Documentation

template<typename Type, typename Alloc = allocator<Type>>
std::deque< Type, Alloc >::deque | ( | const allocator_type & | a = `allocator_type()` | ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 635 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
std::deque< Type, Alloc >::deque | ( | size_type | n,
|  | const value_type & | value,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline]`

Create a deque with copies of an exemplar element.

Parameters:

  | n | The number of elements to initially create.
  | value | An element to copy.

This constructor fills the deque with n copies of value.

Definition at line 645 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
std::deque< Type, Alloc >::deque | ( | size_type | n | ) | `[inline, explicit]`

Create a deque with default elements.

Parameters:

  | n | The number of elements to initially create.

This constructor fills the deque with n copies of a default-constructed element.

Definition at line 658 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
std::deque< Type, Alloc >::deque | ( | const deque< Type, Alloc > & | x | ) | `[inline]`

Deque copy constructor.

Parameters:

  | x | A deque of identical element and allocator types.

The newly-created deque uses a copy of the allocation object used by x.

Definition at line 669 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
template<typename InputIterator>
std::deque< Type, Alloc >::deque | ( | InputIterator | first,
|  | InputIterator | last,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline]`

Builds a deque from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a deque consisting of copies of the elements from [first, last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 689 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
std::deque< Type, Alloc >::~deque | ( |  | ) | `[inline]`

| The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 703 of file stl_deque.h.

## Member Function Documentation

template<typename Type, typename Alloc = allocator<Type>>
template<typename InputIterator>
void std::deque< Type, Alloc >::assign | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Assigns a range to a deque.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

This function fills a deque with copies of the elements in the range [first,last).

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 744 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::assign | ( | size_type | n,
|  | const value_type & | __val
| ) | `[inline]`

Assigns a given value to a deque.

Parameters:

  | n | Number of elements to be assigned.
  | val | Value to be assigned.

This function fills a deque with n copies of the given value. Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 727 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
const_reference std::deque< Type, Alloc >::at | ( | size_type | n | ) | const`[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 935 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
reference std::deque< Type, Alloc >::at | ( | size_type | n | ) | `[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 921 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
const_reference std::deque< Type, Alloc >::back | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the last element of the deque. Definition at line 974 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
reference std::deque< Type, Alloc >::back | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the last element of the deque. Definition at line 962 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
const_iterator std::deque< Type, Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order. Definition at line 769 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
iterator std::deque< Type, Alloc >::begin | ( |  | ) | `[inline]`

| Returns a read/write iterator that points to the first element in the deque. Iteration is done in ordinary element order. Definition at line 761 of file stl_deque.h. Referenced by std::deque< Type, Allocator >::deque(), std::deque< Type, Alloc >::operator=(), and std::operator==().

template<typename Type, typename Alloc>
void std::deque< Type, Alloc >::clear | ( |  | ) |

| Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 170 of file deque.tcc. Referenced by std::deque< Type, Alloc >::erase().

template<typename Type, typename Alloc = allocator<Type>>
bool std::deque< Type, Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the deque is empty. (Thus begin() would equal end().) Definition at line 870 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
const_iterator std::deque< Type, Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order. Definition at line 785 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
iterator std::deque< Type, Alloc >::end | ( |  | ) | `[inline]`

| Returns a read/write iterator that points one past the last element in the deque. Iteration is done in ordinary element order. Definition at line 777 of file stl_deque.h. Referenced by std::deque< Type, Allocator >::deque(), std::deque< Type, Alloc >::operator=(), and std::operator==().

template<typename Type, typename Alloc>
deque< Type, Alloc >::iterator std::deque< Type, Alloc >::erase | ( | iterator | first,
|  | iterator | last
| ) |

Remove a range of elements.

Parameters:

  | first | Iterator pointing to the first element to be erased.
  | last | Iterator pointing to one past the last element to be erased.

Returns:
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the deque accordingly.

The user is cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 132 of file deque.tcc.

References std::deque< Type, Alloc >::clear(), std::copy(), std::copy_backward(), and std::deque< Type, Alloc >::size().

template<typename Type, typename Alloc>
deque< Type, Alloc >::iterator std::deque< Type, Alloc >::erase | ( | iterator | position | ) |

Remove element at given position.

Parameters:

  | position | Iterator pointing to element to be erased.

Returns:
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the deque by one.

The user is cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 111 of file deque.tcc.

References std::copy(), std::copy_backward(), std::deque< Type, Alloc >::pop_back(), and std::deque< Type, Alloc >::pop_front().

Referenced by std::deque< Type, Alloc >::operator=().

template<typename Type, typename Alloc = allocator<Type>>
const_reference std::deque< Type, Alloc >::front | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the deque. Definition at line 954 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
reference std::deque< Type, Alloc >::front | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the first element of the deque. Definition at line 946 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
allocator_type std::deque< Type, Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Get a copy of the memory allocation object. Definition at line 752 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
template<typename InputIterator>
void std::deque< Type, Alloc >::insert | ( | iterator | position,
|  | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Inserts a range into the deque.

Parameters:

  | position | An iterator into the deque.
  | first | An input iterator.
  | last | An input iterator.

This function will insert copies of the data in the range [first,last) into the deque before the location specified by pos. This is known as "range insert."

Definition at line 1102 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::insert | ( | iterator | position,
|  | size_type | n,
|  | const value_type & | x
| ) | `[inline]`

Inserts a number of copies of given data into the deque.

Parameters:

  | position | An iterator into the deque.
  | n | Number of elements to be inserted.
  | x | Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Definition at line 1087 of file stl_deque.h.

template<typename Type, typename Alloc>
deque< Type, Alloc >::iterator std::deque< Type, Alloc >::insert | ( | iterator | position,
|  | const value_type & | x
| ) |

Inserts given value into deque before specified iterator.

Parameters:

  | position | An iterator into the deque.
  | x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location.

Definition at line 90 of file deque.tcc.

References std::deque< Type, Alloc >::push_back(), and std::deque< Type, Alloc >::push_front().

Referenced by std::deque< Type, Alloc >::operator=().

template<typename Type, typename Alloc = allocator<Type>>
size_type std::deque< Type, Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the size() of the largest possible deque. Definition at line 830 of file stl_deque.h.

template<typename Type, typename Alloc>
deque< Type, Alloc > & std::deque< Type, Alloc >::operator= | ( | const deque< Type, Alloc > & | x | ) |

Deque assignment operator.

Parameters:

  | x | A deque of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 69 of file deque.tcc.

References std::deque< Type, Alloc >::begin(), std::copy(), std::deque< Type, Alloc >::end(), std::deque< Type, Alloc >::erase(), std::deque< Type, Alloc >::insert(), and std::deque< Type, Alloc >::size().

template<typename Type, typename Alloc = allocator<Type>>
const_reference std::deque< Type, Alloc >::operator[] | ( | size_type | n | ) | const`[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 897 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
reference std::deque< Type, Alloc >::operator[] | ( | size_type | n | ) | `[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 884 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::pop_back | ( |  | ) | `[inline]`

| Removes last element. This is a typical stack operation. It shrinks the deque by one. Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called. Definition at line 1053 of file stl_deque.h. Referenced by std::deque< Type, Alloc >::erase().

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::pop_front | ( |  | ) | `[inline]`

| Removes first element. This is a typical stack operation. It shrinks the deque by one. Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called. Definition at line 1032 of file stl_deque.h. Referenced by std::deque< Type, Alloc >::erase().

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::push_back | ( | const value_type & | x | ) | `[inline]`

Add data to the end of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1011 of file stl_deque.h.

Referenced by std::deque< Type, Alloc >::insert().

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::push_front | ( | const value_type & | x | ) | `[inline]`

Add data to the front of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 991 of file stl_deque.h.

Referenced by std::deque< Type, Alloc >::insert().

template<typename Type, typename Alloc = allocator<Type>>
const_reverse_iterator std::deque< Type, Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order. Definition at line 802 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
reverse_iterator std::deque< Type, Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last element in the deque. Iteration is done in reverse element order. Definition at line 793 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
const_reverse_iterator std::deque< Type, Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order. Definition at line 819 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
reverse_iterator std::deque< Type, Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order. Definition at line 811 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::resize | ( | size_type | new_size | ) | `[inline]`

Resizes the deque to the specified number of elements.

Parameters:

  | new_size | Number of elements the deque should contain.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are default-constructed.

Definition at line 863 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::resize | ( | size_type | new_size,
|  | const value_type & | x
| ) | `[inline]`

Resizes the deque to the specified number of elements.

Parameters:

  | new_size | Number of elements the deque should contain.
  | x | Data with which new elements should be populated.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are populated with given data.

Definition at line 844 of file stl_deque.h.

template<typename Type, typename Alloc = allocator<Type>>
size_type std::deque< Type, Alloc >::size | ( |  | ) | const`[inline]`

| Returns the number of elements in the deque. Definition at line 825 of file stl_deque.h. Referenced by std::deque< Type, Alloc >::erase(), std::deque< Type, Alloc >::operator=(), std::operator==(), and std::deque< Type, Allocator >::resize().

template<typename Type, typename Alloc = allocator<Type>>
void std::deque< Type, Alloc >::swap | ( | deque< Type, Alloc > & | x | ) | `[inline]`

Swaps data with another deque.

Parameters:

  | x | A deque of the same element and allocator types.

This exchanges the elements between two deques in constant time. (Four pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(d1,d2) will feed to this function.

Definition at line 1155 of file stl_deque.h.

Referenced by std::swap().

The documentation for this class was generated from the following files:

- stl_deque.h
- deque.tcc